/*
  (c) 2005 Antonio Cunei, All rights reserved.

  This file is part of the Runabout Emulation Layer for PolyD.

  The Runabout Emulation Layer for PolyD is free software;
  you can redistribute it and/or modify it under the terms of
  the GNU General Public License as published by the Free
  Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  The Runabout Emulation Layer for PolyD is distributed
  in the hope that it will be useful, but WITHOUT ANY WARRANTY;
  without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE. See the GNU General Public License
  for more details.

  You should have received a copy of the GNU General Public License
  along with the Runabout Emulation Layer for PolyD; if not, write
  to the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
  Boston, MA  02111-1307  USA
*/

package ovm.polyd.runemu;

/**
 * Simple general interface for Runabout emulation.
 * Antonio Cunei
 * 
 * @version $Revision: 1.2 $, $Date: 2005/04/02 07:42:32 $
 * @author Antonio Cunei
 *
 */
public interface RunaboutBase {
 /**
  * Visit an <code>Object</code>
  */
 public void visit(Object o);
 /**
  * Visit a <code>byte</code>
  */
 public void visit(byte o);
 /**
  * Visit a <code>short</code>
  */
 public void visit(short o);
 /**
  * Visit an <code>int</code>
  */
 public void visit(int o);
 /**
  * Visit a <code>long</code>
  */
 public void visit(long o);
 /**
  * Visit a <code>float</code>
  */
 public void visit(float o);
 /**
  * Visit a <code>double</code>
  */
 public void visit(double o);
 /**
  * Visit a <code>char</code>
  */
 public void visit(char o);
 /**
  * Visit a <code>boolean</code>
  */
 public void visit(boolean o);
}
