/*
  (c) 2005 Antonio Cunei, All rights reserved.

  This file is part of the Runabout Emulation Layer for PolyD.

  The Runabout Emulation Layer for PolyD is free software;
  you can redistribute it and/or modify it under the terms of
  the GNU General Public License as published by the Free
  Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  The Runabout Emulation Layer for PolyD is distributed
  in the hope that it will be useful, but WITHOUT ANY WARRANTY;
  without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE. See the GNU General Public License
  for more details.

  You should have received a copy of the GNU General Public License
  along with the Runabout Emulation Layer for PolyD; if not, write
  to the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
  Boston, MA  02111-1307  USA
*/

package ovm.polyd.runemu;
import ovm.polyd.policy.*;

import java.io.PrintStream;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;

/**
 * A logging invocation policy suitable to print a trace of
 * all <code>visit</code> methods in a Runabout emulation.
 * that prints on the standard output.
 * 
 * @version $Revision: 1.1 $, $Date: 2005/04/02 05:38:36 $
 * @author Antonio Cunei
 *
 */
public class RunaboutLogInvocation extends Invocation
{

    private static final Invocation theInvocation = new RunaboutLogInvocation();


    /**
     * Returns an instance of this invocation policy.
     * @return an instance of this policy (a singleton)
     */
    public static Invocation theInvocation()
    {
        return theInvocation;
    }

    public Object invoke(Object obj, Method m, Object args[])
        throws Throwable
    {
        System.out.println("Visiting: " + obj.getClass().getName() +
          "(" + args[0].toString() + ":" + args[0].getClass().getName() + ")");
        Object result = super.invoke(obj, m, args);
        return result;
    }

}
